#ifndef STARSIDAProgram_h
#define STARSIDAProgram_h

#include <list>
// #include <map>
// #include <set>
// #include <string>

// #include <cstdint>
// #include <cstdio>

// #include <intel.hpp>  // indirectly includes the unguarded allins.hpp header

// #include "interfaces/STARSTypes.h"
#include "interfaces/abstract/STARSProgram.h"

class STARS_IDA_Program_t : public STARS_Program_t {
public:
	// Data initialization
	virtual void InitData(void);
	void DetermineRootFileName(void);
	bool OpenFiles(void);
	void CloseFiles(void);

	// Get (accessor) methods
	char GetSTARS_ISA_dtyp(void) const { return STARS_ISA_dtyp; };
	int GetSTARS_MD_LAST_SAVED_REG_NUM(void) const { return STARS_MD_LAST_SAVED_REG_NUM; };

	// Set (mutator) methods
	void Set32BitBinary(void); // Set internal state to handle a 32-bit binary
	void Set64BitBinary(void); // Set internal state to handle a 64-bit binary

	// Query methods

	// Printing methods
	virtual void PrintAllCodeToCodeXrefs(STARS_ea_t InstAddr, std::size_t InstSize);

	// Analysis methods
	void ReportTotalCodeSize(unsigned long long TotalCodeSize);
	void InitStaticDataTable(SMPProgram *CurrProg);
	void GetBlockSuccessorTargets(bool CallFlag, STARS_InstructionID_t LastBlockInst, std::size_t InstSize, std::list<STARS_InstructionID_t> &SuccList); // Get successors for LastBlockInst, omitting call targets

private:
	// Data

	char STARS_ISA_dtyp;
	int STARS_MD_LAST_SAVED_REG_NUM;

	// Methods
	void MDInitializeCallerSavedRegs(void);
	void MDInitializeArgumentRegs(void);
	void ComputeGlobalFieldOffsets(struct GlobalVar &CurrGlobal);
	
};

#endif
