#ifndef STARS_irdb_Interface_h
#define STARS_irdb_Interface_h


#include "interfaces/abstract/STARSInterface.h"
#include <libIRDB-core.hpp>
#include <assert.h>

class STARS_IRDB_Interface_t: public STARS_Interface_t
{
public:

	// Constructors
	STARS_IRDB_Interface_t(const FileIR_t* p_firp) : firp(p_firp) {}
		
	// Segment accessors

	virtual STARS_Segment_t *getseg(const STARS_ea_t &addr) { assert(0); return NULL; }
	virtual STARS_Segment_t *getnseg(const int &index) { assert(0); return NULL; }
	virtual std::size_t get_segm_qty() { assert(0); return 0; }; 
	virtual STARS_Segment_t *get_next_seg(const STARS_ea_t &addr) { assert(0); return NULL; }

	// Function accessors

    	// find out how many functions there are
	virtual std::size_t get_func_qty() { assert(0); return 0;}  

    	// get the index-th function
	virtual STARS_Function_t *getn_func(int index) 
	{ assert(0); return 0; }; 

	// get the function at the given address
	virtual STARS_Function_t *get_func(STARS_ea_t ea) 
	{ assert(0); return NULL; }; 

	virtual void get_func_name(const STARS_ea_t &ea, char* name, const std::size_t &len) 
	{ assert(0); }; 

	// Instruction creation.
	virtual STARS_Instruction_t *CreateInst(STARS_InstructionID_t InstID) 
	{ assert(0); return NULL; }; 

	// File methods.
	virtual FILE *STARS_fopen(const char *file, const char *mode) 
	{ assert(0); return NULL; }
	virtual int STARS_fclose(FILE *fp)
	{ assert(0); return 0; }
	virtual int STARS_msg(const char *format, ...)
	{ assert(0); return 0; }
	virtual int STARS_fprintf(FILE *fp, const char *format, ...)
	{ assert(0); return 0; }
	virtual int STARS_fscanf(FILE *fp, const char *format, ...)
	{ assert(0); return 0; }
	virtual long STARS_ftell(FILE *fp)
	{ assert(0); return 0; }
	virtual char *STARS_fgets(char *buffer, int buflen, FILE *fp)
	{ assert(0); return 0; }
	virtual int STARS_fseek(FILE *fp, long offset, int whence)
	{ assert(0); return 0; }
	virtual int STARS_fgetc(FILE *fp)
	{ assert(0); return 0; }

	// String methods
	virtual char *STARS_strncat(char *dst, const char *src, std::size_t dstsize) 
	{ assert(0); return NULL; }
	virtual char *STARS_strncpy(char *dst, const char *src, std::size_t dstsize) 
	{ assert(0); return NULL; }
	virtual int STARS_snprintf(char *buffer, std::size_t n, const char *format, ...)
	{ assert(0); return NULL; }

	// Disasm methods.
	virtual STARS_ssize_t STARS_tag_remove(const char *instr, char *buf, std::size_t bufsize) 
	{ assert(0); return 0; }
	virtual bool STARS_generate_disasm_line(STARS_ea_t addr, char *buf, std::size_t bufsize, int flags = 0) 
	{ assert(0); return 0; }

	// Miscellaneous methods.
	virtual bool InstHasNoCodeXrefs(STARS_InstructionID_t InstID) const
	{ assert(0); return 0; }
	virtual bool IsInstJumpTarget(STARS_InstructionID_t InstID) const
	{ assert(0); return 0; }

	// Find call target; first one, if any, for indirect call
	virtual STARS_InstructionID_t FindFirstCallTarget(STARS_InstructionID_t CallInstID) const 
	{ assert(0); return 0; }

	// Miscellaneous IDA-only methods.
	virtual void AuditTailChunkOwnership(void)
	{ assert(0); return; }
    	virtual void AuditCodeTargets(void)
	{ assert(0); return; }

	// Patch IDA Pro database.
	virtual bool STARS_patch_byte(STARS_ea_t InstAddr, uint32_t ByteValue) 
	{ assert(0); return 0; }

	
private:

	const libIRDB::FileIR_t *firp;
};


#endif


