#ifndef STARSIRDBProgram_h
#define STARSIRDBProgram_h

// #include <map>
// #include <set>
// #include <string>

// #include <cstdint>
// #include <cstdio>

#include "interfaces/STARSTypes.h"
#include "interfaces/abstract/STARSProgram.h"

class STARS_IRDB_Program_t : public STARS_Program_t {
public:
	// Data initialization
	virtual void InitData(void);
	void DetermineRootFileName(void);
	bool OpenFiles(void);
	void CloseFiles(void);

	// Get (accessor) methods
	char GetSTARS_ISA_dtyp(void) const { return STARS_ISA_dtyp; };
	int GetSTARS_MD_LAST_SAVED_REG_NUM(void) const { return STARS_MD_LAST_SAVED_REG_NUM; };

	// Set (mutator) methods
	void Set32BitBinary(void); // Set internal state to handle a 32-bit binary
	void Set64BitBinary(void); // Set internal state to handle a 64-bit binary

	// Query methods

	// Analysis methods
	void ReportTotalCodeSize(unsigned long long TotalCodeSize);
	void InitStaticDataTable(SMPProgram *CurrProg);


private:
	// Data

	FILE *SMPLogFile;
	char STARS_ISA_dtyp;
	int STARS_MD_LAST_SAVED_REG_NUM;

	// Methods
	void MDInitializeCallerSavedRegs(void);
	void MDInitializeArgumentRegs(void);
	
};

#endif
